def fib1(n):
    if n<0:
        raise ValueError("Fibonacci non definito su negativi.")

    if n == 0:
        return 0
    elif n==1:
        return 1
    else:
        return fib1(n-1) + fib1(n-2)

def fib2(n):
    if n<0:
        raise ValueError("Fibonacci non definito su negativi.")

    if n == 0:
        return 0
    elif n==1:
        return 1
 
    F=[0,1]
    while len(F) <= n:
        F.append( F[-1] + F[-2] )

    return F[n]

def fib3(n):
    if n<0:
        raise ValueError("Fibonacci non definito su negativi.")

    if n == 0:
        return 0
    elif n==1:
        return 1
 
    F=[0,1]
    for i in range(2,n+1):
        # calcola Fib(i) e Fib(i-1) da Fib(i-1) e Fib(i-2)
        F[-1], F[-2] = F[-1] + F[-2], F[-1]

    return F[-1]
